/* Squint - Pentomino placement game
 * Copyright (C) 2005 David Turner <novalis@novalis.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110
 */

#include "GamesImpl.h"

GamesImpl::GamesImpl(QWidget* parent, const char* name, bool modal, WFlags f) :
  Games (parent, name, modal, f),
  game()
{}

void GamesImpl::joinGame(QListViewItem* gameItem) {
  game = gameItem->text(1);
  accept();
}


void GamesImpl::addGame(const QString& player, const QString& game) {
  (void) new QListViewItem (games, player, game);
}

void GamesImpl::removeGame(const QString& game) {
  QListViewItem* gameItem = games->findItem (game, 1, ExactMatch);
  if (gameItem) {
    delete gameItem;
  }
}
