/* Squint - Pentomino placement game
 * Copyright (C) 2005 David Turner <novalis@novalis.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110
 */

#include <qpainter.h>
#include <qpen.h>
#include <qbrush.h>

#include "SquintBoard.h"

SquintBoard::SquintBoard(SquintCanvas* canvas) : 
  QCanvasRectangle(0, 0, 12*SQUARE_WIDTH+1, 9*SQUARE_WIDTH+1, canvas->canvas()),
  _canvas(canvas)
{
  show();
}

SquintBoard::~SquintBoard() {}

void SquintBoard::draw(QPainter& painter) {

  QPen qp (Qt::black, 1, Qt::SolidLine);
  QBrush qb (Qt::blue);

  //draw lines (note the fencepost)
  painter.setPen(qp);
  for (int y = 0; y <= 9; ++y) {
    painter.drawLine(0, y * SQUARE_WIDTH, 12*SQUARE_WIDTH, y * SQUARE_WIDTH);
  }
  for (int x = 0; x <= 12; ++x) {
    painter.drawLine(x * SQUARE_WIDTH, 0, x * SQUARE_WIDTH, 9*SQUARE_WIDTH);
  }

  //draw squares
  for (int y = 0; y < 9; ++y) {
    for (int x = 0; x < 12; ++x) {
      if (_canvas->board[y][x]) 
	painter.fillRect(x * SQUARE_WIDTH + 1, y * SQUARE_WIDTH + 1, SQUARE_WIDTH - 1, SQUARE_WIDTH - 1, qb);
    }
  }
}

void SquintBoard::update() {
  QCanvasRectangle::update();
}
