/* Squint - Pentomino placement game
 * Copyright (C) 2005 David Turner &lt;novalis@novalis.org&gt;
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110
 */

#include "Squint.h"
#include "ConnectingImpl.h"
#include "GamesImpl.h"

#include <qsocket.h>

class SquintImpl : public Squint {
  Q_OBJECT
public:
  SquintImpl::SquintImpl();

  void send(const QString& data);
  void send(const QStringList& data);
  void showChat(const QString& who, const QString& what);

  void move(const QStringList& args);

public slots:
  virtual void vFlip();
  virtual void hFlip();
  virtual void rotateCW();
  virtual void rotateCCW();

  virtual void fileNew();
  virtual void restartGame();
  virtual void sendMove();

  void read();
  void cancelled();
  void connected();
  void disconnected();
  void closeEvent(QCloseEvent* ce);
  void sendChat();

private:
  ConnectingImpl *connecting;
  QSocket *socket;
  GamesImpl *games;
  QString name;
};
