/* Squint - Pentomino placement game
 * Copyright (C) 2005 David Turner <novalis@novalis.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110
 */

#include "SquintMove.h"
#include "SquintPiece.h"

SquintMove::SquintMove() :
  piece(0)
{}

SquintMove::SquintMove(SquintPlayer* player, SquintPieceItem* piece, const QStringList& args) :
  player(player), piece(piece)
{

  x = args [2].toInt();
  y = args [3].toInt();
  flip = args [4].toInt();
  rotation = args [5].toInt();

  piece->piece.orient(flip, rotation);

}


QString SquintMove::serialize() {
  QString out = QString( "%1 %2 %3 %4 %5" )
    .arg( piece->piece.name )
    .arg( x )
    .arg( y )
    .arg( flip )
    .arg( rotation );

  return out;

}
