/* Squint - Pentomino placement game
 * Copyright (C) 2005 David Turner &lt;novalis@novalis.org&gt;
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110
 */

#ifndef SQUINTPIECE_H
#define SQUINTPIECE_H

#include <qstring.h>

class SquintPiece {

 public:
  SquintPiece(char* grid, int width, int height, const QString& name);
  void doHFlip();
  void doVFlip();
  void doRotate(int amount = 0);
  void orient(int flip, int rotation);


  QString name;
  int width, height;
  int grid[5][5];

  /* Take the base shape.  Apply the flip.  Then apply any rotations.
That's how flip and rotate work.  What this means is that flipping
already-rotated things isn't so straightforward.   See code for details.
  */
  int flip, rotation;
};

#endif
