/* Squint - Pentomino placement game
 * Copyright (C) 2005 David Turner &lt;novalis@novalis.org&gt;
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110
 */

class SquintPieceItem;

#ifndef SQUINTPIECEITEM_H
#define SQUINTPIECEITEM_H

#include <qpoint.h>
#include <qcanvas.h>
#include <qpainter.h>

#include "SquintBoard.h"

#include "SquintPiece.h"

class SquintPieceItem : public QCanvasRectangle {

 public:
  SquintPieceItem(QCanvas* parent, char* grid, int width, int height, const QString& name);
  virtual void draw(QPainter &p);
  virtual int rtti () const;
  void setHome(QPoint p);
  void goHome();
  void snapToGrid(int gridx, int gridy);
  void doHFlip();
  void doVFlip();
  void doRotate(int amount);

  QPoint corner();

  static const int RTTI = 10462;

  SquintPiece piece;

  QPoint home;
};

#endif
