/* Squint - Pentomino placement game
 * Copyright (C) 2005 David Turner &lt;novalis@novalis.org&gt;
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110
 */

#ifndef _SQUINTCLIENT_H
#define _SQUINTCLIENT_H

#include <qstring.h>
#include <qsocket.h>

#include "SquintClient.h"
#include "SquintServer.h"
#include "SquintGame.h"

class SquintClient : public QObject {
Q_OBJECT
 public:
  SquintClient(QSocket* socket, SquintServer* server);
  ~SquintClient();
  void startGame(bool yourTurn);

  void partnerDisconnected();
  void send(const QString& data);
  void send(const QStringList& data);
  void sendError(const QString& error);

  void sendMove(const QString& move);
  void createGame(const QString& gameName);
  void announceYouJoin();
  void announceJoin(SquintClient* player);
  void announceGame(SquintGame* game);
  void unannounceGame(SquintGame* game);

  SquintGame* game;

  bool dead;

public slots:
  void disconnected();
  void read();

 private:
  QSocket* socket;
  SquintServer* server;
  QString name;
  
};
#else 
class SquintClient;
#endif
