/* Squint - Pentomino placement game
 * Copyright (C) 2005 David Turner <novalis@novalis.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110
 */

#ifndef _SQUINTGAME_H
#define _SQUINTGAME_H

#include <qstring.h>
#include "SquintClient.h"

struct SquintGame {
  public:
  int turn;
  SquintClient* players[2];
  int board [9][12];
  QString name;

  SquintGame (const QString& n, SquintClient *player);
  void restart(const QString& n, SquintClient *client);
  void join(SquintClient *client);
  void chat(const QString& str, SquintClient *client);
  void startGame();
  void clientDisconnected(SquintClient *client);

  bool isTurn(SquintClient *client);
  void move(const QString& str);

};

#else
class SquintGame;
#endif
