/* Squint - Pentomino placement game
 * Copyright (C) 2005 David Turner &lt;novalis@novalis.org&gt;
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110
 */

#ifndef _SQUINT_SERVER_H
#define _SQUINT_SERVER_H

#include <qsocket.h>
#include <qserversocket.h>
#include <list>

#include "SquintGame.h"
#include "SquintClient.h"

class SquintServer : public QServerSocket {
Q_OBJECT
public:
  SquintServer(QObject *parent = 0);

  void newGame(SquintGame *game);
  bool removeGame(SquintGame *game);

  SquintGame* findGameByName(const QString& name);
  void sendGames(SquintClient *to);

  void discardClient(SquintClient *client);

protected:
  void newConnection(int socketDescriptor);

private:
  typedef std::list<SquintClient*> ClientList;
  typedef std::list<SquintGame*> GameList;
  GameList games;
  ClientList clients;
  
};

#else

class SquintServer;

#endif
